package com.zauzoo.gpsservice.entity;

public final class AddressBuilder {
    private Long id;
    private String street;
    private String city;
    private String number;
    private String zip;
    private String place;
    private String state;
    private String additional;

    private AddressBuilder() {
    }

    public static AddressBuilder anAddress() {
        return new AddressBuilder();
    }

    public AddressBuilder withId(Long id) {
        this.id = id;
        return this;
    }

    public AddressBuilder withStreet(String street) {
        this.street = street;
        return this;
    }

    public AddressBuilder withCity(String city) {
        this.city = city;
        return this;
    }

    public AddressBuilder withNumber(String number) {
        this.number = number;
        return this;
    }

    public AddressBuilder withZip(String zip) {
        this.zip = zip;
        return this;
    }

    public AddressBuilder withPlace(String place) {
        this.place = place;
        return this;
    }

    public AddressBuilder withState(String state) {
        this.state = state;
        return this;
    }

    public AddressBuilder withAdditional(String additional) {
        this.additional = additional;
        return this;
    }

    public Address build() {
        Address address = new Address();
        address.setId(id);
        address.setStreet(street);
        address.setCity(city);
        address.setNumber(number);
        address.setZip(zip);
        address.setPlace(place);
        address.setState(state);
        address.setAdditional(additional);
        return address;
    }
}
