package com.zauzoo.gpsservice.entity;

import org.hibernate.annotations.CreationTimestamp;

import javax.persistence.*;
import javax.validation.constraints.NotEmpty;
import javax.validation.constraints.NotNull;
import java.util.Date;

/**
 * Historie automobilu.
 * */
@Entity
public class History {
    @Id
    @GeneratedValue
    private Long id;
    @ManyToOne
    @NotNull
    private Address address;
    @ManyToOne
    private Car car;
    @ManyToOne
    @NotNull
    private User user;
    @CreationTimestamp
    private Date creationDate;
    @NotNull
    private Double latitude;
    @NotNull
    private Double longtitude;

    public History() {
    }

    public History( Address address,  User user,  Double latitude,  Double longtitude) {
        this.address = address;
        this.user = user;
        this.latitude = latitude;
        this.longtitude = longtitude;
    }

    public History( Address address, Car car,  User user,  Double latitude,  Double longtitude) {
        this.address = address;
        this.car = car;
        this.user = user;
        this.latitude = latitude;
        this.longtitude = longtitude;
    }

    public History(Long id, @NotNull Address address, Car car, @NotNull User user, Date creationDate, @NotNull Double latitude, @NotNull Double longtitude) {
        this.id = id;
        this.address = address;
        this.car = car;
        this.user = user;
        this.creationDate = creationDate;
        this.latitude = latitude;
        this.longtitude = longtitude;
    }

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public Address getAddress() {
        return address;
    }

    public void setAddress(Address address) {
        this.address = address;
    }

    public Car getCar() {
        return car;
    }

    public void setCar(Car car) {
        this.car = car;
    }

    public Date getCreationDate() {
        return creationDate;
    }

    public void setCreationDate(Date creationDate) {
        this.creationDate = creationDate;
    }

    public Double getLatitude() {
        return latitude;
    }

    public void setLatitude(Double latitude) {
        this.latitude = latitude;
    }

    public Double getLongtitude() {
        return longtitude;
    }

    public void setLongtitude(Double longtitude) {
        this.longtitude = longtitude;
    }

    public User getUser() {
        return user;
    }

    public void setUser(User user) {
        this.user = user;
    }
}

