package com.zauzoo.gpsservice.maps;

import java.math.BigDecimal;
import java.math.MathContext;
import java.math.RoundingMode;

/**
 * Třída pro výpočet vzdálenosti dvou bodů.
 * Zdroj: https://www.geeksforgeeks.org/minimum-distance-from-a-point-to-the-line-segment-using-vectors/
 *
 * */
class GFG {
    public static class Pair {
        BigDecimal F, S;
        public Pair(BigDecimal F, BigDecimal S) {
            this.F = F;
            this.S = S;
        }
        public Pair() {
        }
    }

    public static BigDecimal minDistance(Pair A, Pair B, Pair E) {
        Pair AB = new Pair();
        AB.F = B.F.subtract(A.F);
        AB.S = B.S.subtract(A.S);

        Pair BE = new Pair();
        BE.F = E.F.subtract(B.F);
        BE.S = E.S.subtract(B.S);

        Pair AE = new Pair();
        AE.F = E.F.subtract(A.F);
        AE.S = E.S.subtract(A.S);

        BigDecimal AB_BE, AB_AE;

        AB_BE = (AB.F.multiply(BE.F)).add((AB.S.multiply(BE.S)));
        AB_AE = (AB.F.multiply(AE.F)).add((AB.S.multiply(AE.S)));

        BigDecimal reqAns;

        if (AB_BE.compareTo(new BigDecimal(0.0)) > 0) {

            BigDecimal y = E.S.subtract(B.S);
            BigDecimal x = E.F.subtract(B.F);
            BigDecimal add = (x.pow(2)).add(y.pow(2));
            reqAns = add.sqrt(MathContext.DECIMAL128);
        }
        else if (AB_AE.compareTo(new BigDecimal(0.0)) < 0) {
            BigDecimal y = E.S.subtract(A.S);
            BigDecimal x = E.F.subtract(A.F);
            BigDecimal add = (x.pow(2)).add((y.pow(2)));
            reqAns = add.sqrt(MathContext.DECIMAL128);
        }
        else {
            BigDecimal x1 = AB.F;
            BigDecimal y1 = AB.S;
            BigDecimal x2 = AE.F;
            BigDecimal y2 = AE.S;
            BigDecimal add = x1.multiply(x1).add(y1.multiply(y1));
            BigDecimal mod = add.sqrt(MathContext.DECIMAL128);
            BigDecimal abs = (x1.multiply(y2).subtract(y1.multiply(x2))).abs();
            try{
                reqAns = abs.divide(mod, 8, RoundingMode.HALF_UP);
            } catch (Exception ex){
                reqAns = new BigDecimal(0.0);
            }
        }
        return reqAns;
    }
}