package com.zauzoo.gpsservice.maps;

import org.openstreetmap.osmosis.core.domain.v0_6.Way;
import org.openstreetmap.osmosis.xml.common.CompressionMethod;
import org.openstreetmap.osmosis.xml.v0_6.impl.BaseXMLReader;
import org.openstreetmap.osmosis.xml.v0_6.impl.OsmHandler;

import java.io.File;
import java.util.Collections;
import java.util.Map;

public class ServerXMLReader extends BaseXMLReader {
    protected OsmMapComponent.SpringSink sink;

    /**
     * Default Constructor.
     *
     * @param file              File to parse
     * @param enableDateParsing whether to enable date parsing or not
     * @param method            The compression method if any
     */
    public ServerXMLReader(File file, boolean enableDateParsing, CompressionMethod method) {
        super(file, enableDateParsing, method);
    }

    public Map<Long, Way> read(OsmMapComponent.SpringSink sink){
        this.sink = sink;
        this.sink.initialize(Collections.emptyMap());
        this.handleXML(new OsmHandler(this.sink, this.isEnableDateParsing()));
        this.sink.complete();

        return this.sink.getWays();
    }
}
