package com.zauzoo.gpsservice.repository;

import com.zauzoo.gpsservice.entity.Address;
import com.zauzoo.gpsservice.entity.Car;
import com.zauzoo.gpsservice.entity.History;
import org.springframework.data.repository.CrudRepository;

import java.util.Date;
import java.util.List;

public interface HistoryRepository extends CrudRepository<History, Long> {
    List<History> findAll();
    List<History> findAllByCar(final Car car);
    List<History> findAllByCar_Externalid(final String id);
    List<History> findAllByCreationDateBeforeAndCreationDateAfter(final Date before, final Date after);
    List<History> findAllByCar_IdAndCreationDateBeforeAndCreationDateAfter(final String carid, final Date before, final Date after);
    List<History> findAllByCar_IdAndAddress_City(final String carid, final String city);
    List<History> findAllByCar_IdAndAddress_State(final String carid, final String state);
    List<History> findAllByCar_IdAndAddress_Place(final String carid, final String place);
    List<History> findAllByCar_IdAndAddress_Number(final String carid, final String address);
    List<History> findAllByCar_IdAndAddressContains(final String carid, final Address address);
}
